/*->c.main */



#include "stdafx.h"

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <stdlib.h>
#include <setjmp.h>


#include "windows.h"


#include "os.h"
#include "etc.h"

#include "deb.h"

#include "imp.h"


#include "fsx.h"


#include "bits.h"

#include "config.h"


#include "colours.h"
#include "styles.h"
#include "frames.h"



#include "main.h"




filehdr * docdata;

int       nostylecheck;
int       directorymode;


char      inputpath[FSMAXPATH];
char    * inputcat;

FILE    * inputfp;
FILE    * outputfp;




static jmp_buf xraisejmp;




void terminate(char * message)
{
 ATOM atom;

// xprintf("terminate %s",message);
 

 atom=GlobalAddAtom(message);
 
 longjmp(xraisejmp,(int)atom);
}


int borderwidth;



 


int main(int argc,char * argv[])
{ 
 int        i;
 fstat      f;
 int        result;
	char     * p;
 
 result=setjmp(xraisejmp);
 if(!result)
 {
  if(argc<3) terminate("Syntax: Convert <input file> <output file>");
  {
   for(i=0;i<argc;i++)
   {
    if(!cstrcmp(argv[i],"-nostylecheck")) nostylecheck=1;
   }


  	strcpy(inputpath,argv[0]);
  	p=fs_leaf(inputpath);
  	strcpy(p,"transimp.txt");
			FILE * fp;
			fp=fopen(inputpath,"rb");
			if(fp)
			{
				fscanf(fp,"width:%d",&borderwidth);
				fclose(fp);
			}

//		printf("width %d",borderwidth);

			//   terminate("101");

   strcpy(inputpath,argv[1]);
   inputcat=inputpath+strlen(inputpath);

   fs_stat(inputpath,&f);
   if(!f.object)  terminate("Input file does not exist.");
   if(f.object>1) directorymode=1;


   xprintf("%s %s\r\n",inputpath,argv[2]);

   if(directorymode)
   {
    strcpy(inputcat,"\\!DocData.d87");
   }

   inputfp=fopen(inputpath,"rb");
   if(!inputfp) terminate("Can't open input file");
   else
   {
    docdata=(filehdr*)malloc(sizeof(filehdr));
    if(!docdata) terminate("Not enough memory for file header.");

    if(fread(docdata,sizeof(filehdr),1,inputfp)!=1)terminate("Can't read input");
    if(docdata->v3<MINVERSION) terminate("File produced by too old a version of Impression");

    docdata=(filehdr*)realloc(docdata,docdata->contents2);
    if(!docdata) terminate("Not enough memory");

    if(fread(((char*)docdata)+sizeof(filehdr),
              docdata->contents2-sizeof(filehdr),1,inputfp)!=1) 
                                         terminate("Can't read enough input");



    if(directorymode)
    {
     fclose(inputfp);
    }

    initcolours();



    
    initstyles();




    initframes();


    outputfp=fopen(argv[2],"wb");
    if(!outputfp) terminate("Can't open output file");


    fprintf(outputfp,"//->DDLFile\n");
    fprintf(outputfp,"// Produced by TransIMP\n");
    fprintf(outputfp,"//\n");
    fprintf(outputfp,"\n\n");
    fprintf(outputfp,"DOC={document}\n");
    fprintf(outputfp,"\n");


    dumpcolours();

    dumpstyles();

    dumpframes();

    if(!directorymode)
    {
     fclose(inputfp);
    }

    fclose(outputfp);
   }
  }
 }



 return(result);
}



int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

 return(main(__argc,__argv));

 USE(hInstance);
 USE(nCmdShow);
 USE(lpCmdLine);
 USE(hPrevInstance);
}
